function [Out,bDs,Error]=set_chol(N,verbose,varargin)
  % example of 'set_fun' function used in bench
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('d',2,@isscalar);
  p.addParamValue('fprintf',@(varargin) fprintf(varargin{:}));
  p.addParamValue('kind','upper',@(x) ismember(lower(x),{'lower','upper'})); 
  p.addParamValue('class','double',@(x) ismember(x,{'double','single'}));
  p.addParamValue('complex',false,@islogical);
  p.parse(varargin{:});
  R=p.Results;
  classname=R.class;
  Fprintf=R.fprintf;
  d=R.d;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  
  if R.complex
    A=fc_amat.random.randnherpd(N,d,'class',classname);
  else
    A=fc_amat.random.randnsympd(N,d,'class',classname);
  end
  
  
  if ~isreal(A)
    str0='Hermitian';
    str=['complex ',classname]; 
  else
    str0='Symmetric';
    str=classname; 
  end
  
  if strcmp(lower(R.kind),'upper')
    Error={@(X) max(norm(X'*X-A)) + all(~istriu(X),0)};
  else
    Error={@(X) max(norm(X*X'-A)) + all(~istril(X),0)};
  end
  
  if verbose
    Fprintf('# %s Positive Definite matrices\n',str0);
    Fprintf('# -> amat[%s] with (N,m,n)=(N,%d,%d)\n',str,size(A,1),size(A,2));
    Fprintf('# Error function: %s\n',fc_tools.utils.fun2str(Error{1}));
  end
  bDs{1}=fc_bench.bdata('N',N,'%d',10);
  Out={A};
end
